package mw;

import java.util.*;
import java.util.Hashtable;
import java.util.Enumeration;
//import pnp.persistent.*;


/**
 * @author Noel Cross 
 * @author Michael Bartley
 */
public class MultiState extends State implements Persistent {
  public boolean ordered;
  Integer id;

  public static int count = 0;
  private static Hashtable cache = new Hashtable();

  public MultiState() {
    super();
    count++;

    ordered = false;
  }
  public void setId(Object id){
    this.id = (Integer)id;
    if(id != null){
      cache.put(this.id, this);
    }
  }

  public Object getId(){return id;}

  public void setOrdered(){ordered = true;}
  public void setUnOrdered(){ordered = false;}
  public boolean isOrdered(){return ordered;}
  public boolean isUnOrdered(){return ordered;}

  public boolean containedIn(Vector states){
    boolean b = false;
    int limit = states.size();
    for(int i = 0; i < limit; i++){
      State state = (State)states.elementAt(i);
      if(state == this){
	b = true;
      }
    }
    return b;
  }

  public String getStringValue(){
    return getName();
  }
  public String toString(){
    return new String("name: " + getName());
  }
  public void print(){
    System.out.println(toString());
  }

  // Persistence stuff
  private static PersistentPeer thePeer;
  public static void setPersistentPeer(PersistentPeer peer) {thePeer = peer;}
  public PersistentPeer getPersistentPeer() {return thePeer;}

  public static MultiState restore(Integer id) {
    MultiState ms = (MultiState)cache.get(id);
    if(ms == null){
      ms = new MultiState();
      ms.setId(id);
      ms.restore();
    }
    //try again.
    ms = (MultiState)cache.get(id);
    return ms;
  }
  public static void restoreAll(){
    System.out.println("Start restoreAll for MultiState");
    MultiState ms = new MultiState();
    ms.setId(null);
    ms.restore();
    System.out.println("End restoreAll");
  }
  public static Enumeration elements(){
    return cache.elements();
  }

  public void restore() {    
    try{
      thePeer.restore(this);
    }catch(NothingRestoredException e){}
  }
  public void update() {thePeer.update(this);}
  public void insert() {thePeer.insert(this);}
  public void delete() {thePeer.delete(this);}
}
