/**
 * InfoFrame.java
 *  Displays information about the current version of NaviKey
 * @author Michael Bartley
 * @date 7/1/99
 */

package mw;
import java.awt.*;

public class InfoFrame extends Frame{
    private Button closebutton;

    public InfoFrame(){
	super("About NaviKey v2.3");
	closebutton = new Button("Close");
	add("South", closebutton);
	String info = "Basic NaviKey overview:\n\tNaviKey is a Java applet which provides a web interface for\nDELTA files.  The graphical interface contains four panels:  characters are\nselected in the top left; states of the selected character are available\nin the top right; the bottom left panel displays what selections have been\nmade; and the bottom right panel displays all matching items.  Selecting\nany item will bring up a complete description of that item, as well as links\nto images or other resources if they are available.\n\nIntelligence feature:\n\tThe checkbox options toggles NaviKey's use of intelligence.\nWhen selected, NaviKey only displays the characters and states that will\nreduce the number of item matches; characters or states which are not\napplicable to the remaining items or apply to all of the items in the same\nform are no longer displayed.  The drawback to this feature is that it\nslows NaviKey's performance, so it is up to the user to activate it or not.\n\nResource Information:\n\tIf the Delta data set contains images for individual items, they\ncan be viewed from the item description windows.  Clicking on an item\nbrings up its description, and if any images are available there will be links\non top of the description.  Should your browser not fully support Java 1.1\nfeatures, the images will appear at full size and may overrun your\nscreen.  If your browser does support Java 1.1, the images appear in a small\nwindow with scrollbars.\n\nOther Performance Issues:\n\tIf a character is selected which requires a numeric input, the\nstate panel displayed in the top right switches to an input panel.  After\ninputing either a single measurement or a range of values, the add button\nwill input the values and reduce the character list based on these values.\nNo intelligent features currently apply to the numeric input.  Finally, if\nNaviKey runs sluggishly the best way to tell when it is done and ready for\nnew selections is to watch the top right panel.  When this, the state panel,\nis blacked out, NaviKey is ready for a new selection.\n\nNaviKey v2.3 has been developed by Michael Bartley and Noel Cross.\nEmail any comments about the program to mbartley@fas.harvard.edu or\nnoelc@oeb.harvard.edu";
	TextArea ta = new TextArea(info);
	ta.setEditable(false);
	add("Center",ta);
    }

    public boolean handleEvent(Event e){
	if(e.target == closebutton){
	    if(e.id == Event.ACTION_EVENT){
		this.dispose();
	    }
	}
	return super.handleEvent(e);
    }

}
