package mw;

import java.util.Vector;

/**
 * An Attribute is member of an Item object.  Attributes are subclassed.
 *
 * @author Michael Bartley
 * @author Noel Cross
 */

public abstract class Attribute {
  ItemCharacter ic;
  String comment;
  public Attribute(){

  }
  public void setItemCharacter(ItemCharacter ichar){ic = ichar;}
  public ItemCharacter getItemCharacter(){return ic;}
  
  public void setComment(String str){comment = str;}
  public String getComment(){return comment;}

  public abstract Vector getCommentedStates();
  public abstract Vector getStates();
  public abstract boolean containsState(State st);

  public boolean isMultistate(){
    return ic.isMultiState();
  }

  public boolean isNumeric(){
    return ic.isNumeric();
  }

  public boolean isText(){
    return ic.isText();
  }

  public abstract void addCommentedState(State st, String comment);
  public abstract boolean sameAs(Attribute a);
  public abstract String toString();
  public abstract void print();
}
