package mw;

/**
 * <pre>
 * This class  models a DELTA  character file as defined in the 
 * Definition of the Delta Format
 * 14 March, 1995
 * Dallwitz & Paine 
 *
 * </pre>
 * @author Noel Cross
 * @author Michael Bartley
 */

public class BasicItemCharacter implements Sortable{
  Integer id;
  String type;  //UM, OM, RN, IN, or TE
  String feature;


  //boolean isMandatory

  public BasicItemCharacter() {
    //id = new Integer(0);
    type = new String("UM"); //default to unordered multi.
    feature = new String();
  }

  public void setId(Object id){
    if (id instanceof Integer)
      this.id = (Integer)id;
  }
  public void setType(String type){this.type = type;}
  public void setFeature(String feature){this.feature = feature;}
  public void setName(String s){setFeature(s);}

  public Object getId(){return id;}
  public String getType(){return type;}
  public String getFeature(){return feature;}
  public String getName(){return feature;}

  public boolean greaterThan(Sortable s){
    boolean rv = false;
    if(s instanceof BasicItemCharacter){
      int i = ((Integer)s.getId()).intValue();
      rv = ((id.intValue() > i) ? true : false);
    }
    return rv;
  }

  public boolean lessThan(Sortable s){
    boolean rv = false;
    if(s instanceof BasicItemCharacter){
      int i = ((Integer)s.getId()).intValue();
      rv = ((id.intValue() < i) ? true : false);
    }
    return rv;
  }

  public boolean equalTo(Sortable s){
    boolean rv = false;
    if(s instanceof BasicItemCharacter){
      int i = ((Integer)s.getId()).intValue();
      rv = ((id.intValue() == i) ? true : false);
    }
    return rv;
  }


  public boolean isNumeric(){
    if(type.equals("IN") || type.equals("RN")){
      return true;
    }
    else {
      return false;
    }
  }

  public boolean isText(){
    boolean b = false;
    if(type.equals("TE"))
      b = true;
    return b;
  }

  public boolean isMultiState(){
    if(type.equals("UM") || type.equals("OM")) {
      return true;
    }
    else {
      return false;
    }
  }

  public void print() {
    System.out.println(toString());
  }  
  public String toString() {
    StringBuffer sb = new StringBuffer();
    if(id != null) {
      sb.append("id :" + id);
    }
    if(type != null) {
      sb.append("type :" + type);
    }
    if(feature != null) {
      sb.append("feature :" + feature);
    }
    return new String(sb);
  }

}










