package mw;

import java.net.*;
import java.io.*;
import java.util.Vector;

/**

 * HttpClientDelta.java
 * @author Michael Bartley
 * 7/31/98
 */

public class HttpClientDelta implements DeltaInterface{
  URL url; //server to connect to
  private String urlString;

  public HttpClientDelta(URL url){
    this.url = url;
    urlString = url.toString() + '?';
  }

  public void setUrl(URL url){
    this.url = url;
    urlString = url.toString() + '?';
  }

  public URL getUrl(){
    return url;
  }

  //vector of BasicItemCharacters returned
  public Vector getItemCharacterList(Vector basicStates, boolean intelligent){
    String query = "method=" + URLEncoder.encode("getItemCharacterList");
    if(basicStates != null){
      for(int i=0; i<basicStates.size(); i++){
	query += "&";
	BasicState bs = (BasicState)basicStates.elementAt(i);
	query += "name" + i + "=" + URLEncoder.encode(bs.getName());
	query += "&";
	query += "characterId" + i + "=" + URLEncoder.encode(bs.getCharacterId().toString());
      }
    }
    //pass in intelligence
    query += "&smarts=" + (intelligent ? "true" : "false");
    System.out.println("Query is: " + query);
    int cl = query.length();
    Vector rv = new Vector();
    try{
      URL currentUrl = new URL(urlString + query);
      URLConnection uc = currentUrl.openConnection();
      uc.setDoOutput(true);
      uc.setDoInput(true);
      uc.setUseCaches(false);
      uc.setAllowUserInteraction(false);

      //DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
      //dos.writeBytes(query);
      //dos.close();
      
      DataInputStream dis = new DataInputStream(uc.getInputStream());
      Vector values = new Vector();
      String nextLine;
      while((nextLine = dis.readLine()) != null){
	values.addElement(nextLine);
	//System.out.println(nextLine);
      }
      dis.close();
      //Now have vector values filled with id's, types, and strings (I hope)
      // must process and then return
      if(values.size()%3 != 0)
	return null;
      for(int i=0; i<values.size(); i += 3){
	BasicItemCharacter bic = new BasicItemCharacter();
	bic.setId(new Integer((String)values.elementAt(i)));
	bic.setType((String)values.elementAt(i+1));
	bic.setFeature((String)values.elementAt(i+2));
	rv.addElement(bic);
      }
    }
    catch(IOException e){
      System.out.println("Error in communication. Get ItemCharacterList"+e);
    }
    //System.out.println("Done with getItemCharacterList");
    return rv;
  }

  //vector of BasicStates returned
  public Vector getStateList(Vector basicStates, Object characterId, boolean intelligent){
    String query = "method=" + URLEncoder.encode("getStateList");
    query += "&";
    query += "forCharacterId=" + URLEncoder.encode(characterId.toString());
    for(int i=0; i<basicStates.size(); i++){
      query += "&";
      BasicState bs = (BasicState)basicStates.elementAt(i);
      query += "name" +i+ "=" + URLEncoder.encode(bs.getName());
      query += "&";
      query += "characterId" +i+ "=" + URLEncoder.encode(bs.getCharacterId().toString());
    }
    //add intelligence info
    query += "&smarts=" + URLEncoder.encode(intelligent ? "true" : "false");
    int cl = query.length();
    Vector rv = new Vector();
    try{
      URL currentUrl = new URL(urlString + query);
      URLConnection uc = currentUrl.openConnection();
      uc.setDoOutput(true);
      uc.setDoInput(true);
      uc.setAllowUserInteraction(false);
      //DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
      
      //dos.writeBytes(query);
      //dos.close();
      
      DataInputStream dis = new DataInputStream(uc.getInputStream());
      Vector values = new Vector();
      String nextLine;
      while((nextLine = dis.readLine()) != null){
	values.addElement(nextLine);
	//System.out.println(nextLine);
      }
      dis.close();
      //Now have vector values filled with id's and strings (I hope)
      // must process and then return
      if(values.size()%2 != 0)
	return null;
      for(int i=0; i<values.size(); i += 2){
	BasicState bs = new BasicState();
	bs.setCharacterId(new Integer((String)values.elementAt(i)));
	bs.setName((String)values.elementAt(i+1));
	rv.addElement(bs);
      }
    }
    catch(Exception e){
      System.out.println("Error in communication. GetStateList"+e);
    }
    return rv;
  }
  
  //vector of BasicItems returned
  public Vector getItemList(Vector basicStates){
    String query = "method=" + URLEncoder.encode("getItemList");
    if(basicStates != null){
      for(int i=0; i<basicStates.size(); i++){
	query += "&";
	BasicState bs = (BasicState)basicStates.elementAt(i);
	query += "name" +i+ "=" + URLEncoder.encode(bs.getName());
	query += "&";
      query += "characterId" +i+ "=" + URLEncoder.encode(bs.getCharacterId().toString());
      }
    }
    int cl = query.length();
    Vector rv = new Vector();
    try{
      URL currentUrl = new URL(urlString + query);
      URLConnection uc = currentUrl.openConnection();
      uc.setDoOutput(true);
      uc.setDoInput(true);
      uc.setAllowUserInteraction(false);
      //DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
      
      //dos.writeBytes(query);
      //dos.close();
      
      DataInputStream dis = new DataInputStream(uc.getInputStream());
      Vector values = new Vector();
      String nextLine;
      while((nextLine = dis.readLine()) != null){
	values.addElement(nextLine);
	//System.out.println(nextLine);
      }
      dis.close();
      //Now have vector values filled with id's and strings (I hope)
      // must process and then return
      if(values.size()%2 != 0)
	return null;
      for(int i=0; i<values.size(); i += 2){
	BasicItem bi = new BasicItem();
	bi.setId(new Integer((String)values.elementAt(i)));
	bi.setName((String)values.elementAt(i+1));
	rv.addElement(bi);
      }
    }
    catch(IOException e){
      System.out.println("Error in communication. GetItemList"+e);
    }
    return rv;
  }

  public BasicItemCharacter getBasicItemCharacter(Object itemCharacterId){
    String query = "method=" + URLEncoder.encode("getBasicItemCharacter");
    query += "&";
    query += "forCharacterId=" + URLEncoder.encode(itemCharacterId.toString());

    int cl = query.length();
    Vector rv = new Vector();
    try{
      URL currentUrl = new URL(urlString + query);
      URLConnection uc = currentUrl.openConnection();
      uc.setDoOutput(true);
      uc.setDoInput(true);
      uc.setAllowUserInteraction(false);
      //DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
      
      //dos.writeBytes(query);
      //dos.close();
      
      DataInputStream dis = new DataInputStream(uc.getInputStream());
      Vector values = new Vector();
      String nextLine;
      while((nextLine = dis.readLine()) != null){
	values.addElement(nextLine);
	//System.out.println(nextLine);
      }
      dis.close();
      //Now have vector values filled with id's and strings (I hope)
      // must process and then return
      if(values.size() != 3){
	return null;
      }
      BasicItemCharacter bic = new BasicItemCharacter();
      bic.setId(new Integer((String)values.elementAt(0)));
      bic.setType((String)values.elementAt(1));
      bic.setFeature((String)values.elementAt(2));
      return bic;
    }
    catch(Exception e){
      System.out.println("Error in communication. "+e);
    }
    return null;
  }

   //for use in generating description list NOT USED, SHOULD BE REMOVED!!!
   public Item getItem(Object itemId){
      return null;
    }

  public String getItemTitle(Object itemId){
    String query = "method=" + URLEncoder.encode("getItemTitle");
    query += "&";
    query += "forItemId=" + URLEncoder.encode(itemId.toString());

    int cl = query.length();
    Vector rv = new Vector();
    try{
      URL currentUrl = new URL(urlString + query);
      URLConnection uc = currentUrl.openConnection();
      //URLConnection uc = url.openConnection();
      uc.setDoOutput(true);
      uc.setDoInput(true);
      uc.setAllowUserInteraction(false);
      //DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
      
      //dos.writeBytes(query);
      //dos.close();
      
      DataInputStream dis = new DataInputStream(uc.getInputStream());
      Vector values = new Vector();
      String nextLine;
      while((nextLine = dis.readLine()) != null){
	values.addElement(nextLine);
	//System.out.println(nextLine);
      }
      dis.close();
      //Now have vector values filled with id's and strings (I hope)
      // must process and then return
      if(values.size() < 1){
	return null;
      }
      return (String)values.elementAt(0);
    }
    catch(Exception e){
      System.out.println("Error in communication. "+e);
    }
    return null;
  }

  public Vector getItemDescription(Object itemId){
    String query = "method=" + URLEncoder.encode("getItemDescription");
    query += "&";
    query += "forItemId=" + URLEncoder.encode(itemId.toString());

    int cl = query.length();
    Vector rv = new Vector();
    try{
      URL currentUrl = new URL(urlString + query);
      URLConnection uc = currentUrl.openConnection();
      //URLConnection uc = url.openConnection();
      uc.setDoOutput(true);
      uc.setDoInput(true);
      uc.setAllowUserInteraction(false);

      //DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
      //dos.writeBytes(query);
      //dos.close();
      
      DataInputStream dis = new DataInputStream(uc.getInputStream());
      Vector values = new Vector();
      String nextLine;
      while((nextLine = dis.readLine()) != null){
	values.addElement(nextLine);
	//System.out.println(nextLine);
      }
      dis.close();
      //Now have vector values filled with id's and strings (I hope)
      // must process and then return
      return values;
    }
    catch(Exception e){
      System.out.println("Error in communication. "+e);
    }
    return null;
  }

  public Vector getItemResources(Object itemId){
    String query = "method=" + URLEncoder.encode("getItemResources");
    query += "&";
    query += "forItemId=" + URLEncoder.encode(itemId.toString());

    int cl = query.length();
    Vector rv = new Vector();
    try{
      URL currentUrl = new URL(urlString + query);
      URLConnection uc = currentUrl.openConnection();

      //URLConnection uc = url.openConnection();
      uc.setDoOutput(true);
      uc.setDoInput(true);
      uc.setAllowUserInteraction(false);

      //DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
      //dos.writeBytes(query);
      //dos.close();
      
      DataInputStream dis = new DataInputStream(uc.getInputStream());
      Vector values = new Vector();
      String nextLine;
      while((nextLine = dis.readLine()) != null){
	values.addElement(nextLine);
	//System.out.println(nextLine);
      }
      dis.close();
      //Now have vector values filled with id's and strings (I hope)
      // must process and then return
      if(values.size()%5 != 0){
	return null;
      }
      for(int i = 0; i < values.size(); i += 5){
	String mimeType = (String)values.elementAt(i);
	if(mimeType.equals("image")){
	  Resource r = new ImageResource();
	  String s;
	  s = (String)values.elementAt(i+1);
	  if(!s.equals("none"))
	    r.setLocation(new URL(s));
	  s = (String)values.elementAt(i+2);
	  if(!s.equals("none"))
	    r.setFile(s);
	  s = (String)values.elementAt(i+3);
	  if(!s.equals("none"))
	    r.setNotes(s);
	  s = (String)values.elementAt(i+4);
	  if(!s.equals("none"))
	    r.setTitle(s);
	  rv.addElement(r);
	}
      }
      return rv;
    }
    catch(IOException e){
      System.out.println("Error in communication. GetResources"+e);
    }
    return null;
  }

}
